
int
copy_fragment(
    HANDLE in_h,
    HANDLE out_h,
    HANDLE log_h,
    char* buff,
    ULONG xbs,
    ULONG* _r,
    __int64 f_ptr
    )
{
        int ok;
        ULONG r, w;
        ULONG read_bytes;
        __int64 lba = (__int64)(f_ptr/(unsigned __int64)bs);

        fill_buffer(buff, xbs, fill_stringW, fill_stringA);
        ok = 0;
        for(r=0; r<retry; r++) {
            set_file_pointer(in_h, f_ptr);
            set_file_pointer(out_h, f_ptr);
            read_bytes = 0;
            if(!ReadFile(in_h, buff, xbs, &read_bytes, NULL) ||
                read_bytes != xbs) {
                read_bytes = GetLastError();
                if(!r) {
                    printf("Can't read block (%d bytes) at offset %I64d (LBA %I64d) error %d\n", xbs, f_ptr, lba, read_bytes);
                }
                Sleep(1000);
                if(new_target && (fill_stringA || fill_stringW)) {
                    goto set_filler;
                }
            } else {
                if(r) {
                    printf("Read on attempt #%d\n", r+1);
                }
                ok = 1;
set_filler:
                for(w=0; w<3; w++) {
                    WriteFile(out_h, buff, xbs, &read_bytes, NULL);
                    if(read_bytes != xbs) {
                        read_bytes = GetLastError();
                        printf("Can't write block at offset %I64d (LBA %I64d) error %d\n", f_ptr, lba, read_bytes);
                        if(read_bytes == 1450) {
                            // insufficient resources
                            set_file_pointer(out_h, f_ptr);
                            Sleep(1);
                            continue;
                        }
                        ok = ok ? -1 : -2;
                        break;
                    }
                    break;
                }
                break;
            }
        }
        if(ok<0) {
            if(log_h) {
                sprintf(LogBuffer, "output error at %I64d (LBA %I64d) size %d (%d blocks), error %d\n", f_ptr, lba, xbs, xbs/bs, read_bytes);
                WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
            }
        } else
        if(!ok) {
            bads += xbs;
            if(log_h) {
                sprintf(LogBuffer, "bad at %I64d (LBA %I64d) size %d (%d blocks)\n", f_ptr, lba, xbs, xbs/bs);
                WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
            }
        } else
        if(r) {
            susp += xbs;
            if(log_h) {
                sprintf(LogBuffer, "unreliable at %I64d (LBA %I64d) size %d (%d blocks)\n", f_ptr, lba, xbs, xbs/bs);
                WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
            }
        }
        //f_ptr += xbs;
        //*copy_count += xbs;

    *_r = r;
    return ok;
} // end copy_fragment()
